{"cells": [{"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "# TP - Impl\u00e9mentation des listes chain\u00e9es"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "## 1. Rappel"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "### 1.1 D\u00e9finition\n\n> Une __liste cha\u00een\u00e9e__ est une structure permettant d'impl\u00e9menter une liste, c'est-\u00e0-dire une s\u00e9quence finie de valeurs (de m\u00eame type ou non). \n\n> Les \u00e9l\u00e9ments dont dits __cha\u00een\u00e9s__ car chque \u00e9l\u00e9ment poss\u00e8de l'adresse m\u00e9moire de l'\u00e9l\u00e9ment suivant de la liste."}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "![](https://g.gravizo.com/svg?digraph%20foo%20%7B%0A%20%20%20%20%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%2C%20arrowsize%3D1.2%5D%3B%0A%20%20%20%20%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%7D)\n\nOn a repr\u00e9sent\u00e9 ici une liste cha\u00een\u00e9e de trois \u00e9l\u00e9ments :\n\n- Le premier est 21, et il pointe vers l'adresse m\u00e9moire du second ;\n- Le deuxi\u00e8me \u00e9l\u00e9ment est 15 et il pointe vers l'adresse m\u00e9moire du troisi\u00e8me ;\n- Le troisi\u00e8me \u00e9l\u00e9ment est 45. Il ne pointe vers rien (l'adresse du suivant est None). On a atteint la fin de la liste chain\u00e9e."}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "### 1.2. Interface d'une liste chain\u00e9e\n\nLa liste chain\u00e9e est un type abstrait, et admet les op\u00e9rations suivantes :\n\n- `cr\u00e9er une liste vide` qui renvoie un objet de type liste chain\u00e9e. _La liste chain\u00e9e existe et elle est vide_.\n- `longueur(l)`. qui renvoie un objet de type entier. _Le nombre d'\u00e9l\u00e9ments pr\u00e9sents dans la liste chain\u00e9e l est renvoy\u00e9.\n- `ins\u00e9rer(l, i, e)`. _L'\u00e9l\u00e9ment e est ins\u00e9r\u00e9 \u00e0 la position i dans la liste chain\u00e9e l_.\n- `lire(l, i)` qui renvoie un objet. _L'\u00e9l\u00e9ment \u00e0 la position i dans la liste chain\u00e9e l est renvoy\u00e9__.\n- `rechercher(l, e)` qui renvoie un objet de type entier. _L'\u00e9l\u00e9ment e est recherch\u00e9 dans la liste chain\u00e9e l et on renvoie son index (sa position)_.\n- `supprimer(l, i)`. _L'\u00e9l\u00e9ment situ\u00e9 \u00e0 la position i est supprim\u00e9 de la liste chain\u00e9e l_.\n- `modifier(l, i, e)`. _L'\u00e9l\u00e9ment situ\u00e9 \u00e0 la position i dans la liste chain\u00e9e l est \u00e9cras\u00e9 par le nouvel \u00e9l\u00e9ment e_."}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "## 2. Objectifs\n\nL'objectif de ce TD est d'impl\u00e9menter la structure Liste en Python.\n\nNous allons cr\u00e9er un module Maillon, qui sera enrichi au fur et \u00e0 mesure de la s\u00e9ance."}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "## 3. Impl\u00e9mentation en Python\n\n### 3.1. Un maillon\n\nCommen\u00e7ons donc par construire la classe `Maillon` qui poss\u00e8de une valeur et un lien vers le maillon suivant."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "trusted": false}, "cell_type": "code", "source": "class Maillon :\n    \"\"\"Chainon d'une liste chain\u00e9e\"\"\"\n    def __init__(self, valeur = None, suivant = None):\n        self.valeur = valeur\n        self.suivant = suivant", "execution_count": null, "outputs": []}, {"metadata": {"slideshow": {"slide_type": "slide"}, "solution": true}, "cell_type": "markdown", "source": "R\u00e9ponse ici"}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true, "trusted": false}, "cell_type": "code", "source": "# R\u00e9ponse\n", "execution_count": null, "outputs": []}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "\u2753 __\u00c0 Faire__ : Repr\u00e9senter la liste chain\u00e9e $l$ correspondant \u00e0 l'instruction suivante :\n\n```python\nl = Maillon(72, Maillon(6, Maillon(34, Maillon(8))))\n```"}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true}, "cell_type": "markdown", "source": "R\u00e9ponse ici"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "Une primitive classique et importante consiste \u00e0 connaitre le caract\u00e8re vide ou non d'une liste chain\u00e9e.\n\n\ud83d\udcbb __\u00c0 Faire__ : Impl\u00e9menter le pr\u00e9dicat `est_vide` dans le module `Maillon` qui correspond \u00e0 la sp\u00e9cification suivante :\n\n```python\ndef est_vide(l):\n    '''\n    Indique si la liste chain\u00e9e l est vide\n    :param l: (Maillon) Une liste chain\u00e9e\n    :return: (bool) True si la liste est vide, False sinon. Une liste chain\u00e9e est vide si elle est \u00e9gale \u00e0 None ou si sa valeur est \u00e9gale \u00e0 None\n    :exemples:\n        >>> l = None\n        >>> est_vide(l)\n        True\n        >>> l = Maillon()\n        >>> est_vide(l)\n        True\n        >>> l = Maillon(21)\n        >>> est_vide(l)\n        False\n    '''\n```"}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true, "trusted": false}, "cell_type": "code", "source": "# R\u00e9ponse\n", "execution_count": null, "outputs": []}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "La construction d'une liste chain\u00e9e \u00e0 partir du seul constructeur n'est pas pratique.\n\n\ud83d\udcbb __\u00c0 Faire__ : Impl\u00e9menter la fonction `ajouter` dans le module `Maillon` qui correspond \u00e0 la sp\u00e9cification suivante :\n\n```python\ndef ajouter(l, e):\n    '''\n    ajouter l'\u00e9l\u00e9ment e en t\u00eate de la liste chain\u00e9e l\n    :param l: (Maillon) Une liste chain\u00e9e\n    :param e: (any) Un \u00e9l\u00e9ment\n    :return: (Maillon) La liste chain\u00e9e o\u00f9 e a \u00e9t\u00e9 ins\u00e9r\u00e9 en t\u00eate de l\n    :exemples:\n        >>> l = Maillon()\n        >>> l = ajouter(l, 45)\n        >>> l.valeur\n        45\n        >>> est_vide(l.suivant)\n        True\n        >>> l = ajouter(l, 15)\n        >>> l.valeur\n        15\n        >>> est_vide(l.suivant)\n        False\n        >>> l.suivant.valeur\n        45\n    '''\n```"}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true, "trusted": false}, "cell_type": "code", "source": "# R\u00e9ponse\n", "execution_count": null, "outputs": []}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "\u2753 __\u00c0 Faire__ : Repr\u00e9senter la liste chain\u00e9e $l$ correspondant \u00e0 la s\u00e9quence d'instructions suivante :\n\n```python\n>>> l = Maillon()\n>>> l = ajouter(l, 'i')\n>>> l = ajouter(l, 'l')\n>>> l = ajouter(l, 'o')\n>>> l = ajouter(l, 'p')\n```"}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true}, "cell_type": "markdown", "source": "R\u00e9ponse ici"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "Soit la d\u00e9finition r\u00e9cursive de la fonction d'affichage d'un maillon $m$ :\n\n$ Soit~un~maillon~m,~de~valeur~v~et~de~maillon~suivant~s,~afficher(m) = \\left\\{ \\begin{array}{ll} 'None' {~si~} v~est~vide \\\\ 'v \\rightarrow None' {~si~} s~est~vide \\\\ 'v \\rightarrow afficher(s)' {~sinon~}\\end{array}\\right.$\n\n\ud83d\udcbb __\u00c0 Faire__ : Impl\u00e9menter la m\u00e9thode `__str__` de classe `Maillon` correspondante.\n\nExemple :\n```python\n>>> m = Maillon(21, Maillon(15, Maillon(45)))\n>>> print(m)\n21 -> 15 -> 45 -> None\n```"}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true, "trusted": false}, "cell_type": "code", "source": "# R\u00e9ponse\n", "execution_count": null, "outputs": []}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "### 3.2. Longueur d'une liste chain\u00e9e\n\nNous allons cr\u00e9er maintenant une fonction `longueur` qui calcule la longueur d'une liste cha\u00een\u00e9, i.e le nombre de maillons de cette chaine.\n\n\n```python\ndef longueur(l):\n    '''\n    renvoie la longueur de la liste chain\u00e9e\n    :param l: (Maillon) Une liste chain\u00e9e\n    :return: (int) Le nombre d'\u00e9l\u00e9ments de la liste chain\u00e9e, 0 si elle est vide\n    :exemples:\n        >>> l = None\n        >>> longueur(l)\n        0\n        >>> l = Maillon()\n        >>> longueur(l)\n        0\n        >>> l = Maillon(21)\n        >>> longueur(l)\n        1\n        >>> l = Maillon(21, Maillon(15, Maillon(45))\n        >>> longueur(l)\n        3\n    '''\n```"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "Il est possible d'\u00e9tablir une d\u00e9finition de la fonction `longueur` de mani\u00e8re r\u00e9cursive.\n\n$Soit~l~une~liste~chain\u00e9e,~longueur(l) = \\left\\{ \\begin{array}{ll}     0 {~si~} l~est~vide \\\\     1 +~??? {~sinon.} \\end{array}\\right.$\n\n\u2753 __\u00c0 Faire__ : Compl\u00e9ter la d\u00e9finition de la fonction `longueur`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true}, "cell_type": "markdown", "source": "R\u00e9ponse ici"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "\ud83d\udcbb __\u00c0 Faire__ : Impl\u00e9menter la fonction `longueur` dans le module `Maillon`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true, "trusted": false}, "cell_type": "code", "source": "# R\u00e9ponse\n", "execution_count": null, "outputs": []}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "\u2753__\u00c0 Faire__ : Quelle est la complexit\u00e9 de cette fonction, en nombre d'additions ?"}, {"metadata": {"slideshow": {"slide_type": "slide"}, "solution": true}, "cell_type": "markdown", "source": "R\u00e9ponse ici"}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "### 3.3. Insertion d'un \u00e9l\u00e9ment\n\nCr\u00e9er une fonction r\u00e9cursive `inserer(l, i, e)` qui ins\u00e8re l'\u00e9l\u00e9ment $e$ \u00e0 la position $i$ dans la liste chain\u00e9e $l$ pass\u00e9e en argument et renvoie la nouvelle liste chain\u00e9e.\n\nLes sch\u00e9mas suivants doivent pouvoir vous aider \u00e0 construire la d\u00e9finition de cette fonction.\n\nSoit la situation intiiale suivante :\n\n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20%0A%20%20%20%20%0A%7D)"}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "Cas 1 : Nous souhaitons ins\u00e9rer l'\u00e9l\u00e9ment 37 \u00e0 la position 0 : \n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20d%20%5Blabel%3D%22%7B%20%3Cdata%3E%2037%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%20%20%20%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20d%3Aref%3Ac%20-%3E%20a%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%2C%20style%3D%22dashed%22%2C%20color%3D%22red%22%5D%3B%0A%20%20%20%20%0A%7D)"}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "Cas 2 : Nous souhaitons ins\u00e9rer l'\u00e9l\u00e9ment 37 \u00e0 une autre position que 0, par exemple 1 :\n\n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20d%20%5Blabel%3D%22%7B%20%3Cdata%3E%2037%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%20%20%20%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%2C%20style%3D%22dashed%22%2C%20color%3D%22red%22%5D%3B%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20d%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20d%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20%0A%7D)"}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "$Soit~l~une~liste~chain\u00e9e,~inserer(l, i, e) = \\left\\{ \\begin{array}{ll}     ??? {~si~} i = 0 \\\\     Maillon(???, ???) {~sinon.} \\end{array}\\right.$\n\n__N.B__ : On suppose que $i \\in [0; longueur(l)[$\n\n\u2753 __\u00c0 Faire__ : Compl\u00e9ter la d\u00e9finition de la fonction `inserer`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true}, "cell_type": "markdown", "source": "R\u00e9ponse ici"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "\ud83d\udcbb __\u00c0 Faire__ : Impl\u00e9menter la fonction `inserer` dans le module `Maillon`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true, "trusted": false}, "cell_type": "code", "source": "# R\u00e9ponse\n", "execution_count": null, "outputs": []}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "### 3.4. Lecture d'un \u00e9l\u00e9ment\n\nCr\u00e9er une fonction r\u00e9cursive `lire(l, i)` qui renvoie la valeur de l'\u00e9l\u00e9ment \u00e0 une position donn\u00e9e $i$ de la liste chain\u00e9e $l$. "}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "Soit la situation d'une liste chain\u00e9e $l$ suivante :\n\n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20%0A%20%20%20%20%0A%7D)\n\n```python\n>>> l = Maillon(21, Maillon(15, Maillon(45)))\n>>> lire(l, 1)\n15\n>>> lire(l, 2)\n45\n>>> lire(l, 0)\n21\n```"}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "$Soit~l~une~liste~chain\u00e9e,~lire(l, i) = \\left\\{ \\begin{array}{ll}     ??? {~si~} i = 0 \\\\     ??? {~sinon.} \\end{array}\\right.$\n\n__N.B__ : On suppose que $i \\in [0; longueur(l)[$\n\n\u2753 __\u00c0 Faire__ : Compl\u00e9ter la d\u00e9finition de la fonction `lire`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true}, "cell_type": "markdown", "source": "R\u00e9ponse ici"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "\ud83d\udcbb __\u00c0 Faire__ : Impl\u00e9menter la fonction `lire` dans le module `Maillon`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true, "trusted": false}, "cell_type": "code", "source": "# R\u00e9ponse\n", "execution_count": null, "outputs": []}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "### 3.5. Recherche d'un \u00e9l\u00e9ment\n\nCr\u00e9er une fonction r\u00e9cursive `rechercher(l, e)` qui renvoie l'indice de la position de l'\u00e9l\u00e9ment $e$ dans la liste chain\u00e9e $l$. \n\nSi $e$ n'est pas dans $l$, la fonction devra renvoyer -1."}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "Soit la situation d'une liste chain\u00e9e $l$ suivante :\n\n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20d%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20c%3Aref%3Ac%20-%3E%20d%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20%0A%7D)\n\n```python\n>>> l = Maillon(15, Maillon(21, Maillon(45, Maillon(21))))\n>>> rechercher(l, 15)\n0\n>>> rechercher(l, 21)\n1\n>>> rechercher(l, 37)\n-1\n```"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "$Soit~l~une~liste~chain\u00e9e,~rechercher(l, e) = \\left\\{ \\begin{array}{ll}     ??? {~si~} l~est~vide \\\\ ??? {~si~} l.valeur = e \\\\     ??? {~sinon.} \\end{array}\\right.$\n\n\u2753 __\u00c0 Faire__ : Compl\u00e9ter la d\u00e9finition de la fonction `rechercher`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true}, "cell_type": "markdown", "source": "R\u00e9ponse ici"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "\ud83d\udcbb __\u00c0 Faire__ : Impl\u00e9menter la fonction `rechercher` dans le module `Maillon`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true, "trusted": false}, "cell_type": "code", "source": "# R\u00e9ponse\n", "execution_count": null, "outputs": []}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "### 3.6. Suppression d'un \u00e9l\u00e9ment\n\nCr\u00e9er une fonction r\u00e9cursive `supprimer(l, i)` qui supprime l'\u00e9l\u00e9ment \u00e0 la position $i$ dans la liste chain\u00e9e $l$ pass\u00e9e en argument et renvoie la nouvelle liste chain\u00e9e.\n\nLes sch\u00e9mas suivants doivent pouvoir vous aider \u00e0 construire la d\u00e9finition de cette fonction.\n\nSoit la situation intiiale suivante :\n\n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20%0A%20%20%20%20%0A%7D)"}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "Cas 1 : Nous souhaitons supprimer l'\u00e9l\u00e9ment \u00e0 la position 0 : \n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%2C%20style%3D%22dashed%22%2C%20color%3D%22red%22%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20%0A%7D)"}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "Cas 2 : Nous souhaitons supprimer l'\u00e9l\u00e9ment \u00e0 une autre position que 0, par exemple 1 :\n\n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%2C%20style%3D%22dashed%22%2C%20color%3D%22red%22%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%2C%20style%3D%22dashed%22%2C%20color%3D%22red%22%5D%3B%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20%0A%7D)"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "$Soit~l~une~liste~chain\u00e9e,~supprimer(l, i) = \\left\\{ \\begin{array}{ll}     ??? {~si~} i = 0 \\\\     Maillon(???, ???) {~sinon.} \\end{array}\\right.$\n\n__N.B__ : On suppose que $i \\in [0; longueur(l)[$\n\n\u2753 __\u00c0 Faire__ : Compl\u00e9ter la d\u00e9finition de la fonction `supprimer`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true}, "cell_type": "markdown", "source": "R\u00e9ponse ici"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "\ud83d\udcbb __\u00c0 Faire__ : Impl\u00e9menter la fonction `supprimer` dans le module `Maillon`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true, "trusted": false}, "cell_type": "code", "source": "# R\u00e9ponse\n", "execution_count": null, "outputs": []}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "### 3.7. Modification d'un \u00e9l\u00e9ment\n\nCr\u00e9er une fonction r\u00e9cursive `modifier(l, i, e)` qui modifie l'\u00e9l\u00e9ment $e$ \u00e0 la position $i$ dans la liste chain\u00e9e $l$ pass\u00e9e en argument.\n\nLes sch\u00e9mas suivants doivent pouvoir vous aider \u00e0 construire la d\u00e9finition de cette fonction.\n\nSoit la situation intiiale suivante :\n\n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20%0A%20%20%20%20%0A%7D)"}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "Cas 1 : Nous souhaitons modifier l'\u00e9l\u00e9ment \u00e0 la position 0 avec la valeur 37:\n\n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_0%20%7B%0A%20%20%20%20%20%20%20%20node%5Bshape%3Dcircle%5D%3B%0A%20%20%20%20%20%20%20%20color%3D%22white%22%3B%0A%20%20%20%20%20%20%20%20d%20%5Blabel%3D%2237%22%2C%20color%3D%22white%22%2C%20fontcolor%3D%22red%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20d%20-%3E%20a%5Bstyle%3D%22dashed%22%2C%20color%3D%22red%22%5D%3B%0A%7D)"}, {"metadata": {"slideshow": {"slide_type": "subslide"}}, "cell_type": "markdown", "source": "Cas 2 : Nous souhaitons ins\u00e9rer l'\u00e9l\u00e9ment \u00e0 une autre position que 0, par exemple 1, avec la valeur 37 :\n\n![](https://g.gravizo.com/svg?digraph%20G%20%7B%0A%20%20%20%20rankdir%3DLR%3B%0A%20%20%20%20node%20%5Bshape%3Drecord%5D%3B%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_0%20%7B%0A%20%20%20%20%20%20%20%20node%5Bshape%3Dcircle%5D%3B%0A%20%20%20%20%20%20%20%20color%3D%22white%22%3B%0A%20%20%20%20%20%20%20%20d%20%5Blabel%3D%2237%22%2C%20color%3D%22white%22%2C%20fontcolor%3D%22red%22%5D%3B%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20subgraph%20cluster_1%20%7B%0A%20%20%20%20%20%20%20%20color%3Dwhite%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%20%20%20%20a%20%5Blabel%3D%22%7B%20%3Cdata%3E%2021%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20b%20%5Blabel%3D%22%7B%20%3Cdata%3E%2015%20%7C%20%3Cref%3E%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20c%20%5Blabel%3D%22%7B%20%3Cdata%3E%2045%20%7C%20None%20%20%7D%22%5D%3B%0A%20%20%20%20%20%20%20%20%0A%20%20%20%20%7D%0A%20%20%20%20%0A%20%20%20%20a%3Aref%3Ac%20-%3E%20b%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20b%3Aref%3Ac%20-%3E%20c%3Adata%20%5Barrowhead%3Dvee%2C%20arrowtail%3Ddot%2C%20dir%3Dboth%2C%20tailclip%3Dfalse%5D%3B%0A%20%20%20%20d%20-%3E%20b%5Bstyle%3D%22dashed%22%2C%20color%3D%22red%22%5D%3B%0A%7D)"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "$Soit~l~une~liste~chain\u00e9e,~modifier(l, i, e) = \\left\\{ \\begin{array}{ll}     ??? {~si~} i = 0 \\\\     ??? {~sinon.} \\end{array}\\right.$\n\n__N.B__ : On suppose que $i \\in [0; longueur(l)[$\n\n\u2753 __\u00c0 Faire__ : Compl\u00e9ter la d\u00e9finition de la fonction `modifier`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true}, "cell_type": "markdown", "source": "R\u00e9ponse ici"}, {"metadata": {"slideshow": {"slide_type": "slide"}}, "cell_type": "markdown", "source": "\ud83d\udcbb __\u00c0 Faire__ : Impl\u00e9menter la fonction `modifier` dans le module `Maillon`."}, {"metadata": {"slideshow": {"slide_type": "subslide"}, "solution": true, "trusted": false}, "cell_type": "code", "source": "# R\u00e9ponse\n", "execution_count": null, "outputs": []}], "metadata": {"celltoolbar": "\u00c9diter les M\u00e9ta-Donn\u00e9es", "kernelspec": {"display_name": "Python 3", "language": "python", "name": "python3"}, "language_info": {"codemirror_mode": {"name": "ipython", "version": 3}, "file_extension": ".py", "mimetype": "text/x-python", "name": "python", "nbconvert_exporter": "python", "pygments_lexer": "ipython3", "version": "3.9.13"}}, "nbformat": 4, "nbformat_minor": 2}